-- =======================
-- =====POWERBAR==========
-- =======================
vexpower_optionPowerbar_OpenTab = {
	["position"] = false,
	["size"] = false,
	["powerpool"] = false,
	["background"] = false,
	["usedenergy"] = false,
	["change"] = false,
	}
	
function vexpower_optionFrame_Powerbar_ToggleTab(tab)
	if vexpower_optionPowerbar_OpenTab[tab] ~= nil then
		vexpower_optionFrame_Powerbar_CloseAllTabs()
		vexpower_optionPowerbar_OpenTab[tab] = true
	end
end
	
function vexpower_optionFrame_Powerbar_CloseAllTabs()
	for key in pairs(vexpower_optionPowerbar_OpenTab) do
		vexpower_optionPowerbar_OpenTab[key] = false
	end
end





-- =======================
-- =====TEXT==============
-- =======================
vexpower_optionText_OpenTab = {
	["content"] = false,
	["format"] = false,
	["position"] = false,
	["misc"] = false,
	["shadow"] = false,
	}
	
function vexpower_optionFrame_Text_ToggleTab(tab)
	if vexpower_optionText_OpenTab[tab] ~= nil then
		vexpower_optionFrame_Text_CloseAllTabs()
		vexpower_optionText_OpenTab[tab] = true
	end
end
	
function vexpower_optionFrame_Text_CloseAllTabs()
	for key in pairs(vexpower_optionText_OpenTab) do
		vexpower_optionText_OpenTab[key] = false
	end
end

vexpower_panelText_textfield = ""
vexpower_panelText_status = " "

function vexpower_panelText_New()
	local newname = vexpower_panelText_getNewName()
	vexpower_default_textfield["x"], vexpower_default_textfield["y"] = vexpower_getNewTextfieldPosition()
	vexpower_parameters["frame"]["energy"]["text"][newname] = vexpower_CopyTable(vexpower_default_textfield)
	vexpower_panelText_textfield = newname
	vexpower_panelText_status = "|CFF00FF00New textfield '"..newname.."' created successfully|r"
	vexpower_panelText_testmode()
end

function vexpower_getNewTextfieldPosition()
	local x = 0
	local y = 0
	local x_new = 0
	local y_new = 0
	local x_current = vexpower_default_textfield["x"]
	local y_current = vexpower_default_textfield["y"]
	local found = false
	local timer = 0
	
	while not(found) do
		if not(vexpower_checkForExistingTextfield(x_current+x, y_current+y)) then
			found = true
			x_new = x_current+x
			y_new = y_current+y
		end
		timer = timer + 1
		
		if timer == 1 then
			x = x + 100
		elseif timer == 2 then
			x = x - 200
			
			x = x - 100
		elseif timer == 3 then
			x = x + 200
			
			y = y + 20
		elseif timer == 4 then
			y = y - 20
			
			y = y - 20
		elseif timer == 5 then
			y = y + 20
			
			x = x + 100
			y = y + 20
			timer = 0
		end
	end
	
	return x_new,y_new
end

function vexpower_checkForExistingTextfield(x, y)
	local returnvalue = false
	for key,val in pairs(vexpower_parameters["frame"]["energy"]["text"]) do
		if val["x"] == x or val["y"] == y then
			returnvalue = true
		end
	end
	return returnvalue
end

function vexpower_panelText_Clone()
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		local newname = vexpower_panelText_getNewName()
		vexpower_parameters["frame"]["energy"]["text"][newname] = vexpower_CopyTable(vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield])
		vexpower_panelText_status = "|CFF00FF00New textfield '"..newname.."' created successfully (Clone of "..vexpower_panelText_textfield..")|r"
		vexpower_panelText_textfield = newname
	else
		vexpower_panelText_status = "|CFFC41F3BCouldn't clone textfield.|r Textfield '"..vexpower_panelText_textfield.."' doesn't exist"
	end
	vexpower_panelText_testmode()
end

function vexpower_panelText_Delete()
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] = nil
		vexpower_text[vexpower_panelText_textfield]:Hide()
		vexpower_text[vexpower_panelText_textfield] = nil
		vexpower_panelText_status = "|CFF00FF00Textfield '"..vexpower_panelText_textfield.."' deleted successfully|r"
		vexpower_panelText_textfield = vexpower_panelText_getFirstTextfield()
	else
		vexpower_panelText_status = "|CFFC41F3BCouldn't delete textfield.|r Textfield '"..vexpower_panelText_textfield.."' doesn't exist"
	end
	vexpower_panelText_testmode()
end

function vexpower_panelText_getFirstTextfield()
	local number = 1
	local found = false
	local exist = false
	
	for key in pairs(vexpower_parameters["frame"]["energy"]["text"]) do
		if vexpower_parameters["frame"]["energy"]["text"][key] ~= nil then
			exist = true
		end
	end
	
	if exist then
		while not(found) do
			local name = tostring(number)
			if vexpower_parameters["frame"]["energy"]["text"][name] ~= nil then
				found = true
			else
				number = number + 1
			end
		end
		return tostring(number)
	else
		return ""
	end
end

function vexpower_panelText_getNewName()
	local number = 1
	local found = false
	while not(found) do
		local name = tostring(number)
		if vexpower_parameters["frame"]["energy"]["text"][name] == nil then
			found = true
		else
			number = number + 1
		end
	end
	return tostring(number)
end

function vexpower_panelText_getDisabled()
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		return false
	else
		return true
	end
end

function vexpower_panelText_setDataDirect(data, key)
	if data == "cptext" then
		if key == "POWERBAR" then
			key = false
		else
			key = true
		end
	end
	
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield][data] = key
	end
end

function vexpower_panelText_getDataDirect(data)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		local temp = vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield][data]
		
		if data == "cptext" then
			if temp == false or temp == nil then
				temp = "POWERBAR"
			else
				temp = "CPSBAR"
			end
		end
		return temp
	end
end

function vexpower_panelText_getDataColor(data)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["color"][data]
	end
end

function vexpower_panelText_setDataColor(data, key)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["color"][data] = key
	end
end

function vexpower_panelText_getDataShadow(folder, data)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		if folder == false then
			return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][data]
		else
			if folder == "color" and data == "a" then
				return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][folder][data]*100
			else
				return vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][folder][data]
			end
		end
	end
end

function vexpower_panelText_setDataShadow(folder, data, key)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		if folder == false then
			vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][data] = key
		else
			vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["shadow"][folder][data] = key
		end
	end
end

function vexpower_panelText_getTextList()
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexpower_parameters["frame"]["energy"]["text"]) do
		if key ~= "profilelist" then
			returnvalue[key]=key
			timer = timer + 1
		end
	end
	
	if timer == 0 then
		returnvalue[""] = "No textfields created"
	end
	
	return returnvalue
end

function vexpower_panel_TagInsert(text, tag)
	if vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield] ~= nil then
		vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["text"] = vexpower_parameters["frame"]["energy"]["text"][vexpower_panelText_textfield]["text"].."["..tag.."] "
	end
end





-- =======================
-- =====CPS===============
-- =======================
vexpower_optionCPs_OpenTab = {
	["layout"] = false,
	["border"] = false,
	["background"] = false,
	["fadeout"] = false,
	["change"] = false,
	["sound"] = false,
	}
	
function vexpower_optionFrame_CPs_ToggleTab(tab)
	if vexpower_optionCPs_OpenTab[tab] ~= nil then
		vexpower_optionFrame_CPs_CloseAllTabs()
		vexpower_optionCPs_OpenTab[tab] = true
	end
end
	
function vexpower_optionFrame_CPs_CloseAllTabs()
	for key in pairs(vexpower_optionCPs_OpenTab) do
		vexpower_optionCPs_OpenTab[key] = false
	end
end





-- =======================
-- =====MARKERS===========
-- =======================
vexpower_optionMarker_OpenTab = {
	["information"] = false,
	["add"] = false,
	["delete"] = false,
	["appearance"] = false,
	}
	
function vexpower_optionFrame_Marker_ToggleTab(tab)
	if vexpower_optionMarker_OpenTab[tab] ~= nil then
		vexpower_optionFrame_Marker_CloseAllTabs()
		vexpower_optionMarker_OpenTab[tab] = true
	end
end
	
function vexpower_optionFrame_Marker_CloseAllTabs()
	for key in pairs(vexpower_optionMarker_OpenTab) do
		vexpower_optionMarker_OpenTab[key] = false
	end
end

vexpower_new_marker_location = ""
vexpower_new_marker_spec = ""
vexpower_edit_marker_location = ""
vexpower_edit_marker_spec = ""
vexpower_edit_marker_spec_prev = ""
vexpower_edit_marker_powertype = {
	["FOCUS"] = true,
	["MANA"] = true,
	["RUNIC_POWER"] = true,
	["ENERGY"] = true,
	["RAGE"] = true,
	}
vexpower_edit_marker_powertype_default = {
	["FOCUS"] = true,
	["MANA"] = true,
	["RUNIC_POWER"] = true,
	["ENERGY"] = true,
	["RAGE"] = true,
	}
vexpower_new_marker_powertype = {
	["FOCUS"] = true,
	["MANA"] = true,
	["RUNIC_POWER"] = true,
	["ENERGY"] = true,
	["RAGE"] = true,
	}
vexpower_marker_status_created = " "
vexpower_marker_status_deleted = " "

function vexpower_marker_loadToEdit(key, spec)
	local markers = {}
	if spec == "a" then
		markers = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"]
	elseif spec == "b" then
		markers = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"]
	else
		markers = vexpower_parameters["frame"]["energy"]["markers"]["points"]
	end
	
	if markers[key] ~= nil then
		vexpower_edit_marker_location = key
		vexpower_edit_marker_spec = spec
		vexpower_edit_marker_spec_prev = spec
		vexpower_edit_marker_powertype = vexpower_CopyTable(markers[key])
	else
		vexpower_marker_status_created = " "
		vexpower_marker_status_deleted = "|CFFC41F3BCouldn't load marker (location: "..pos..", visible for: "..specname..").|r Marker doesn't exist"
	end
end

function vexpower_panel_getMarker(val)
	local markers = {}
	if val == "spec a" then
		markers = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"]
	elseif val == "spec b" then
		markers = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"]
	else
		markers = vexpower_parameters["frame"]["energy"]["markers"]["points"]
	end
	
	local returnvalue = {}
	local timer = 0
	for key,val in pairs(markers) do
		local powertypes = ""
		local powertypeCount = 0
		for k,v in pairs(val) do
			if v then
				local text = ""
				if k == "FOCUS" then
					text = "|CFF"..vexpower_PowerTypeColorHex(k).."F|r"
				elseif k == "MANA" then
					text = "|CFF"..vexpower_PowerTypeColorHex(k).."M|r"
				elseif k == "RUNIC_POWER" then
					text = "|CFF"..vexpower_PowerTypeColorHex(k).."RP|r"
				elseif k == "ENERGY" then
					text = "|CFF"..vexpower_PowerTypeColorHex(k).."E|r"
				elseif k == "RAGE" then
					text = "|CFF"..vexpower_PowerTypeColorHex(k).."R|r"
				end
				if text ~= "" then
					if powertypes ~= "" then
						powertypes = powertypes..", "
					end
					powertypes = powertypes..text
					powertypeCount = powertypeCount + 1
				end
			end
		end
		
		if powertypeCount == 5 then
			powertypes = "|CFF00FF00all powertypes|r"
		end
		
		returnvalue[key]=key.." ("..powertypes..")"
		timer = timer + 1
	end
	
	if timer == 0 then
		returnvalue[""] = "No markers created"
	end
	
	return returnvalue
end

function vexpower_panel_existsmarker()
	local pos = vexpower_new_marker_location
	local spec = vexpower_new_marker_spec
	local overwrite = false
	if spec == "" 	then
		overwrite = vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] ~= nil
	elseif spec == "a" then
		overwrite = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] ~= nil
	elseif spec == "b" then
		overwrite = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] ~= nil
	end
	
	return overwrite
end

function vexpower_panel_addmarker()
	local pos = vexpower_new_marker_location
	local spec = vexpower_new_marker_spec
	
	if vexpower_panel_markercheck(pos) then
		local overwrite
		local specname = ""
		if spec == "" 	then
			specname = "Both Specs"
			overwrite = vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] ~= nil
			vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] = vexpower_CopyTable(vexpower_new_marker_powertype)
		elseif spec == "a" then
			specname = "Primary Spec"
			overwrite = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] ~= nil
			vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] = vexpower_CopyTable(vexpower_new_marker_powertype)
		elseif spec == "b" then
			specname = "Secondary Spec"
			overwrite = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] ~= nil
			vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] = vexpower_CopyTable(vexpower_new_marker_powertype)
		end
		
		if overwrite then
			vexpower_marker_status_created = "|CFF00FF00marker (location: "..pos..", visible for: "..specname..") has been overwritten|r"
			vexpower_marker_status_deleted = " "
		else
			vexpower_marker_status_created = "|CFF00FF00marker (location: "..pos..", visible for: "..specname..") successfully created|r"
			vexpower_marker_status_deleted = " "
		end
	else
		vexpower_marker_status_created = "|CFFC41F3B'"..pos.."' is not a valid marker|r"
		vexpower_marker_status_deleted = " "
	end
end

function vexpower_panel_updateMarker()
	local pos = vexpower_edit_marker_location
	local spec = vexpower_edit_marker_spec
	
	if vexpower_edit_marker_spec_prev == "" then
		if vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] ~= nil then
			vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] = nil
		end
	elseif vexpower_edit_marker_spec_prev == "a" then
		if vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] ~= nil then
			vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] = nil
		end
	elseif vexpower_edit_marker_spec_prev == "b" then
		if vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] ~= nil then
			vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] = nil
		end
	end
	
	if vexpower_panel_markercheck(pos) then
		local specname = ""
		if spec == "" 	then
			specname = "Both Specs"
			vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] = vexpower_CopyTable(vexpower_edit_marker_powertype)
		elseif spec == "a" then
			specname = "Primary Spec"
			vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] = vexpower_CopyTable(vexpower_edit_marker_powertype)
		elseif spec == "b" then
			specname = "Secondary Spec"
			vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] = vexpower_CopyTable(vexpower_edit_marker_powertype)
		end
		
		vexpower_marker_status_deleted = "|CFF00FF00marker (location: "..pos..", visible for: "..specname..") successfully updated|r"
		vexpower_marker_status_created = " "
		vexpower_edit_marker_location = ""
		vexpower_edit_marker_spec = ""
		vexpower_edit_marker_spec_prev = ""
		vexpower_edit_marker_powertype = vexpower_CopyTable(vexpower_edit_marker_powertype_default)
	else
		vexpower_marker_status_deleted = "|CFFC41F3B'"..pos.."' is not a valid marker|r"
		vexpower_marker_status_created = " "
	end
end
function vexpower_panel_markercheck(val)
	local returnvalue = false
	if string.gsub(val, "^%d+%%?", "") == "" then returnvalue = true end
	if val == "" then returnvalue = false end
	return returnvalue
end

function vexpower_panel_deletemarker()
	local pos = vexpower_edit_marker_location
	local spec = vexpower_edit_marker_spec
	local exists = false
	local specname = ""
	
	if spec == "" then
		specname = "Both Specs"
		if vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] ~= nil then
			vexpower_parameters["frame"]["energy"]["markers"]["points"][pos] = nil
			exists = true
		end
	elseif spec == "a" then
		specname = "Primary Spec"
		if vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] ~= nil then
			vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"][pos] = nil
			exists = true
		end
	elseif spec == "b" then
		specname = "Secondary Spec"
		if vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] ~= nil then
			vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"][pos] = nil
			exists = true
		end
	end
	if exists then
		vexpower_marker_status_deleted = "|CFF00FF00marker (location: "..pos..", visible for: "..specname..") successfully deleted|r"
		vexpower_marker_status_created = " "
		vexpower_edit_marker_location = ""
		vexpower_edit_marker_spec = ""
		vexpower_edit_marker_spec_prev = ""
		vexpower_edit_marker_powertype = vexpower_CopyTable(vexpower_edit_marker_powertype_default)
	else
		vexpower_marker_status_deleted = "|CFFC41F3BCouldn't delete marker (location: "..pos..", visible for: "..specname..").|r Marker doesn't exist"
		vexpower_marker_status_created = " "
		vexpower_edit_marker_location = ""
		vexpower_edit_marker_spec = ""
		vexpower_edit_marker_spec_prev = ""
		vexpower_edit_marker_powertype = vexpower_CopyTable(vexpower_edit_marker_powertype_default)
	end
end





-- =======================
-- =====SHOW==============
-- =======================
vexpower_optionShow_OpenTab = {
	["general"] = false,
	["blizz"] = false,
	["ooc"] = false,
	["powertypes"] = false,
	["vehicle"] = false,
	["fadeout"] = false,
	}
	
function vexpower_optionFrame_Show_ToggleTab(tab)
	if vexpower_optionShow_OpenTab[tab] ~= nil then
		vexpower_optionFrame_Show_CloseAllTabs()
		vexpower_optionShow_OpenTab[tab] = true
	end
end
	
function vexpower_optionFrame_Show_CloseAllTabs()
	for key in pairs(vexpower_optionShow_OpenTab) do
		vexpower_optionShow_OpenTab[key] = false
	end
end





-- =======================
-- =====COLOR SETS========
-- =======================
vexpower_colorpresets_load = {
	["1"] = {["r"]=1, ["g"]=0.929, ["b"]=0.0156, ["a"]=1},
	["2"] = {["r"]=0.7725, ["g"]=1, ["b"]=0.043, ["a"]=1},
	["3"] = {["r"]=0.314, ["g"]=1, ["b"]=0.6666, ["a"]=1},
	["4"] = {["r"]=0, ["g"]=1, ["b"]=0.753, ["a"]=1},
	["5"] = {["r"]=0.0078, ["g"]=0.757, ["b"]=1, ["a"]=1},
	["6"] = {["r"]=0.0078, ["g"]=0.757, ["b"]=1, ["a"]=1},
	["change"] = {["r"]=1, ["g"]=0, ["b"]=0, ["a"]=1},
	["used"] = {["r"]=1, ["g"]=0.6, ["b"]=0, ["a"]=1},
	}
vexpower_colorpresets_name = ""
vexpower_colorpresets_status = " "
vexpower_colorpresets_savename = ""
vexpower_colorpresets_savename_prev = ""

function vexpower_newColorPreset()
	vexpower_colorpresets_savename = "new"
	vexpower_colorpresets_name = "-"
	vexpower_colorpresets_load = vexpower_CopyTable(vexpower_default_colorpreset)
end

function vexpower_checkIfOverwritePreset(name)
	if name == nil then
		name = vexpower_colorpresets_savename
	end
	
	if vexpower_default_data["colorpresets"][name] ~= nil then
		return true
	else
		return false
	end
end

function vexpower_saveColorPreset(update)
	local name = ""
	if update then
		name = vexpower_colorpresets_savename_prev
	else
		name = vexpower_colorpresets_savename
	end
	
	if vexpower_profile_checkName(name) then
		vexpower_default_data["colorpresets"][name] = vexpower_CopyTable(vexpower_colorpresets_load)
		if vexpower_checkIfOverwritePreset(name) then
			vexpower_colorpresets_status = "|CFF00FF00Successfully updated ColorPreset '"..name.."'|r"
		else
			vexpower_colorpresets_status = "|CFF00FF00Successfully saved the new ColorPreset '"..name.."'|r"
		end
	else
		if name == "" then
			vexpower_colorpresets_status = "|CFFC41F3BCouldn't save ColorPreset.|r You need to set a name."
		else
			vexpower_colorpresets_status = "|CFFC41F3BCouldn't save ColorPreset '"..name.."'.|r Invalid symbols used."
		end
	end
end

function vexpower_deleteColorPreset()
	if vexpower_colorpresets_name == "" then
		vexpower_colorpresets_status = "ERROR: Can't delete current settings"
	else
		if vexpower_default_data["colorpresets"][vexpower_colorpresets_name] ~= nil then
			vexpower_default_data["colorpresets"][vexpower_colorpresets_name] = nil
			vexpower_colorpresets_status = "|CFF00FF00Successfully deleted ColorPreset '"..vexpower_colorpresets_name.."'|r"
			vexpower_colorpresets_name = ""
			vexpower_colorpresets_savename = ""
			vexpower_newColorPreset()
		else
			vexpower_colorpresets_status = "|CFFC41F3BCouldn't delete ColorPreset '"..vexpower_colorpresets_name.."'.|r Preset doesn't exist"
		end
	end
end

function vexpower_loadColorPreset()
	if vexpower_default_data["colorpresets"][vexpower_colorpresets_name] ~= nil then
		vexpower_parameters["frame"]["combo"]["bg"]["color"] = vexpower_CopyTable(vexpower_default_data["colorpresets"][vexpower_colorpresets_name])
		vexpower_colorpresets_status = "|CFF00FF00Successfully loaded ColorPreset '"..vexpower_colorpresets_name.."'|r"
	else
		vexpower_colorpresets_status = "|CFFC41F3BCouldn't load ColorPreset '"..vexpower_colorpresets_name.."'.|r Preset doesn't exist"
	end
end

function vexpower_getColorPresetList(default)
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexpower_default_data["colorpresets"]) do
		if default then
			local isSet = false
			local presetFor = ""
			local count = 0
			for class,classdata in pairs(vexpower_default_data["classpresets"]) do
				if key == classdata[2] and classdata[1] then
					if count ~= 0 then
						presetFor = presetFor..", "
					end
					presetFor= presetFor..class
					count=count+1
				end
			end
			
			if count==0 then
				returnvalue[key]=key
			else
				returnvalue[key]=key.." (Default for "..presetFor..")"
			end
		else
			returnvalue[key]=key
		end
		timer = timer + 1
	end
	
	if default then
		returnvalue[""]="Current"
	end
	
	if timer == 0 then
		returnvalue[""] = "No profiles created"
	end
	
	return returnvalue
end

function vexpower_gatherPresetData()
	if vexpower_colorpresets_name == "" then
		vexpower_colorpresets_load = vexpower_CopyTable(vexpower_parameters["frame"]["combo"]["bg"]["color"])
	elseif vexpower_default_data["colorpresets"][vexpower_colorpresets_name] ~= nil then
		vexpower_colorpresets_load = vexpower_CopyTable(vexpower_default_data["colorpresets"][vexpower_colorpresets_name])
	end
end





-- =======================
-- =====PROFILES==========
-- =======================
vexpower_profiles_profilename = GetRealmName().." "..select(1, UnitName("player"))
vexpower_profiles_status = " "
vexpower_profiles_status_add = " "

function vexpower_panel_existsProfile()
	if vexpower_profiles[vexpower_profiles_profilename] ~= nil then
		return true
	else
		return false
	end
end

function vexpower_profile_add()
	local key = vexpower_profiles_profilename
	if vexpower_profile_checkName(key) then
		local exists = false
		if vexpower_profiles[key] ~= nil then
			exists = true
		end
		vexpower_profiles[key] = vexpower_CopyTable(vexpower_parameters)
		
		if exists then
			vexpower_profiles_status_add = "|CFF00FF00Successfully updated profile '"..key.."'|r"
			vexpower_profiles_status = " "
		else
			vexpower_profiles_status_add = "|CFF00FF00Successfully saved profile '"..key.."'|r"
			vexpower_profiles_status = " "
		end
	else
		vexpower_profiles_status_add = "|CFFC41F3BCouldn't save profile '"..key.."'.|r Profile name is invalid."
		vexpower_profiles_status = " "
	end
end

function vexpower_profile_update()
	local key = vexpower_profiles_profilename
	if vexpower_profile_checkName(key) then
		vexpower_profiles[key] = vexpower_CopyTable(vexpower_parameters)
		vexpower_profiles_status = "|CFF00FF00Successfully updated profile '"..key.."'|r"
		vexpower_profiles_status_add = " "
	else
		vexpower_profiles_status = "|CFFC41F3B\n\nCouldn't update profile '"..key.."'.|r Profile name is invalid."
		vexpower_profiles_status_add = " "
	end
end

function vexpower_getProfileList(default)
	local returnvalue = {}
	local timer = 0
	for key in pairs(vexpower_profiles) do
		if key ~= "profilelist" then
			if key == vexpower_default_data["profile"] and default then
				returnvalue[key]=key.." (Default Profile)"
			else
				returnvalue[key]=key
			end
			timer = timer + 1
		end
	end
	
	if timer == 0 then
		returnvalue[""] = "No profiles created"
	end
	
	return returnvalue
end

function vexpower_profile_checkName(val)
	local returnvalue = false
	-- local val_edited = val
	-- local legal_symbols = {"%a", "%(", "%)", ":", "%.", ",", " ", "-"}
	-- for i,val in ipairs(legal_symbols) do
		-- val_edited = string.gsub(val_edited, val, "")
	-- end
	-- if val_edited == "" then
		-- returnvalue = true
	-- end
	if val == "" then
		returnvalue = false
	else
		returnvalue = true	-- XXX
	end
	return returnvalue
end

function vexpower_profile_delete(key)
	local key = vexpower_profiles_profilename
	if vexpower_profiles[key] ~= nil then
		vexpower_profiles[key] = nil
		vexpower_profiles_profilename = GetRealmName().." "..select(1, UnitName("player"))
		vexpower_profiles_status = "|CFF00FF00Successfully deleted profile '"..key.."'|r"
		vexpower_profiles_status_add = " "
	else
		vexpower_profiles_status = "|CFFC41F3B\n\nCouldn't delete profile '"..key.."'.|r Profile doesn't exist."
		vexpower_profiles_status_add = " "
	end
end

function vexpower_profile_load()
	local key = vexpower_profiles_profilename
	if vexpower_profiles[key] ~= nil then
		if vexpower_profiles[key] ~= nil then
			vexpower_parameters = vexpower_CopyTable(vexpower_profiles[key])
			vexpower_profiles_status = "|CFF00FF00Successfully loaded profile '"..key.."'|r"
			vexpower_profiles_status_add = " "
		else
			vexpower_profiles_status = "|CFFC41F3B\n\nCouldn't load profile '"..key.."'.|r Profile doesn't exist."
			vexpower_profiles_status_add = " "
		end
	else
		vexpower_profiles_status = "|CFFC41F3B\n\nCouldn't load profile '"..key.."'.|r Profile doesn't exist."
		vexpower_profiles_status_add = " "
	end
end





vexpower_optionDefProfile_OpenTab = {
	["profile"] = false,
	["colorsets"] = false,
	}
	
function vexpower_optionFrame_DefProfile_ToggleTab(tab)
	if vexpower_optionDefProfile_OpenTab[tab] ~= nil then
		vexpower_optionFrame_DefProfile_CloseAllTabs()
		vexpower_optionDefProfile_OpenTab[tab] = true
	end
end
	
function vexpower_optionFrame_DefProfile_CloseAllTabs()
	for key in pairs(vexpower_optionDefProfile_OpenTab) do
		vexpower_optionDefProfile_OpenTab[key] = false
	end
end